;##################################################################
; CHMViewer
; Just a little feasibility test for a CHM viewer
;##################################################################

STRINGS UNICODE

#include CHMViewer.h

#IF X64
	P=8
	#include "C:\Programming\RadASM3\GoAsm\dbg\Debug64.a"
#ELSE
	P=4
	#define PRESERVEXMMREGS
	#include "C:\Programming\RadASM3\GoAsm\dbg\Debug32.a"
#ENDIF

#IF STRINGS UNICODE
	S=2
#ELSE
	S=1
#ENDIF

IDRIML equ 100

CONSTANT SECTION
	IID_IITStorage GUID GUID_IID_IITStorage
	CLSID_MSITStore GUID GUID_CLSID_ITStorage
	IID_IWebBrowser2 GUID GUID_IID_IWebBrowser2

DATA SECTION
	hInstance	HANDLE		?
	pMSITStore	PTR			?
	mkFormat DUS "mk:@MSITStore:%s::/%s",0
	FilePath DUS "win32asm tutorial.chm",0
	pstgOpen PTR ?

	hAtl		HANDLE -1
	hList		HANDLE -1
	hStores		HANDLE -1
	hKeywords	HANDLE -1
	hTab		HANDLE -1
	hFiles		HANDLE -1
	hIML		HANDLE -1
	pWebIUnknown PTR ?
	pIWebBrowser2 PTR ?

CODE SECTION

START:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke InitCommonControls
	invoke CoInitialize,NULL

	invoke OpenCHM,offset FilePath,offset pMSITStore,offset pstgOpen
	test eax,eax
	js >>

	invoke DialogBoxParam,[hInstance],1000,0,ADDR DlgProc,0

	CoInvoke(pstgOpen,IStorage.IUnknown.Release)
	CoInvoke(pMSITStore,IITStorage.IUnknown.Release)
	:

	invoke CoUninitialize

	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses edi,esi,ebx
	LOCAL rect:RECT
	LOCAL pFile:%PTR
	LOCAL cbCopied:D
	LOCAL cbWritten:D
	LOCAL UrlName[1024]:B
	LOCAL UrlPath[1024]:B

	.WM_INITDIALOG
		cmp D[uMsg],WM_INITDIALOG
		jne >>.WM_NOTIFY
		invoke AtlAxWinInit
		invoke GetClientRect,[hwnd],offset rect

		// Create the WebBrowser window
		mov eax,[rect.right]
		sub eax,200
		invoke CreateWindowEx,WS_EX_STATICEDGE,L"AtlAxWin",L"about:blank",WS_CHILD + WS_VISIBLE + WS_VSCROLL, \
			200,0,eax,250,[hwnd],1002,[hInstance],NULL
		mov [hAtl],eax

		mov eax,[rect.bottom]
		sub eax,260

		mov ecx,[rect.right]
		sub ecx,200

		invoke CreateWindowEx,0x200,L"Listbox",L"",0x50010141+WS_VSCROLL, \
			200,260,ecx,eax,[hwnd],1001,[hInstance],NULL

		mov [hList],eax

		invoke SetLastError,0
		invoke CreateWindowEx,0,L"SysTabControl32",L"",0x50018000, \
			0,0,195,[rect.bottom],[hwnd],0,[hInstance],NULL
		mov [hTab],eax

		invoke SetUpTabs,[hTab]

		sub D[rect.bottom],25
		invoke CreateWindowEx,0x200,L"Listbox",L"",0x40010141+WS_VSCROLL, \
			0,25,195,[rect.bottom],[hTab],1005,[hInstance],NULL
		mov [hKeywords],eax

		invoke CreateWindowEx,0x200,L"SysTreeView32",L"",0x50010007+WS_VSCROLL, \
			0,25,195,[rect.bottom],[hTab],1005,[hInstance],NULL
		mov [hStores],eax

		invoke ImageList_LoadImage,[hInstance],IDRIML,16,0,CLR_NONE,IMAGE_BITMAP,LR_CREATEDIBSECTION + LR_LOADTRANSPARENT
		mov [hIML],eax

		invoke SendMessage,[hStores],TVM_SETIMAGELIST,TVSIL_NORMAL,[hIML]

		invoke EnumerateCHMStreams, [pstgOpen], ENUM_STGTY_ALL, offset EnumerationCallback, TVI_ROOT

		invoke AtlAxGetControl, [hAtl],offset pWebIUnknown
		CoInvoke(pWebIUnknown,IWebBrowser2.IUnknown.QueryInterface,offset IID_IWebBrowser2,offset pIWebBrowser2)

		invoke ReadTopics,[pstgOpen],[hList]

		invoke GlobalAlloc,GMEM_FIXED,1024*1024
		mov [pFile],eax
		mov D[cbCopied],1024*1024
		invoke GetKeywordBTREE,[hKeywords],[pstgOpen],[pFile],offset cbCopied

		invoke GlobalFree,[pFile]

		jmp >>.EXIT

	.WM_NOTIFY
	cmp D[uMsg],WM_NOTIFY
	jne >>.WM_COMMAND
		mov eax,[lParam]
		mov eax,[eax+NMHDR.code]
		cmp eax,TCN_SELCHANGE
		jne >>.EXIT
			;Tab selection
			invoke SendMessage,[hTab],TCM_GETCURSEL,0,0
			cmp eax,0
			jne >
				invoke ShowWindow,[hKeywords],SW_HIDE
				invoke ShowWindow,[hStores],SW_SHOWDEFAULT
				jmp >>.EXIT
			:
			cmp eax,1
			jne >>.EXIT
				invoke ShowWindow,[hKeywords],SW_SHOWDEFAULT
				invoke ShowWindow,[hStores],SW_HIDE
				jmp >>.EXIT

	.WM_COMMAND
		cmp D[uMsg],WM_COMMAND
		jne >>.WM_CLOSE
		mov eax,[wParam]
		mov edx,eax
		and eax,0xFFFF
		shr edx,16
		cmp eax,1001
		jne >>.EXIT
		cmp edx,LBN_DBLCLK
		jne >>.EXIT
			invoke SendMessage,[hList],LB_GETCURSEL,0,0
			invoke SendMessage,[hList],LB_GETITEMDATA,eax,0
			invoke URLFromIDXTopic,[pstgOpen],eax,offset UrlPath
			// Format the urlName
			invoke wsprintf,offset UrlName,offset mkFormat,offset FilePath,offset UrlPath
			add esp,16

			invoke GoToURL,[pIWebBrowser2],offset UrlName
		jmp >>.EXIT

	.WM_CLOSE
		cmp D[uMsg],WM_CLOSE
		jne >.DEFPROC
		// Release the interfaces obtained by this dialog
		CoInvoke(pIWebBrowser2,IWebBrowser2.IUnknown.Release)
		CoInvoke(pWebIUnknown,IWebBrowser2.IUnknown.Release)

		invoke ImageList_Destroy,[hIML]

		invoke EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	RET
ENDF

GoToURL FRAME pInterface, pszURL
	LOCAL pbszURL:%PTR
	LOCAL flags:VARIANT

	mov W[flags.vt], VT_I2
	mov W[flags.iVal], 0

	// The strings used by IWebBrowser2 must be BSTR strings
	// so convert them
	invoke SysAllocString,[pszURL]
	mov [pbszURL],eax

	//_self = use the same webbrowser window
	CoInvoke(pInterface,IWebBrowser2.Navigate,[pbszURL],offset flags,"_self",NULL,NULL)
	push eax

	// Free the BSTR
	invoke SysFreeString,[pbszURL]
	pop eax
	RET
ENDF

ReadTopics FRAME pStgStream, hListbox
	uses edi,esi,ebx
	LOCAL pTopics:%PTR
	LOCAL eoTopics:D
	LOCAL pStrings:%PTR
	LOCAL cbTopics:D
	LOCAL cbStrings:D
	LOCAL ObjBuffer[256]:W

	// Get the size of buffers we need to allocate for the data
	mov D[cbTopics],0
	invoke ReadStream,[pStgStream],NULL,L"#TOPICS",offset cbTopics
	mov [cbTopics],eax

	mov D[cbStrings],0
	invoke ReadStream,[pStgStream],NULL,L"#STRINGS",offset cbStrings
	mov [cbStrings],eax

	// Allocate our buffers
	invoke GlobalAlloc,GMEM_FIXED,[cbTopics]
	mov [pTopics],eax
	invoke GlobalAlloc,GMEM_FIXED,[cbStrings]
	mov [pStrings],eax

	// Read the data into the buffers
	invoke ReadStream,[pStgStream],[pTopics],L"#TOPICS",offset cbTopics
	mov eax,[pTopics]
	add eax,[cbTopics]
	mov [eoTopics],eax

	invoke ReadStream,[pStgStream],[pStrings],L"#STRINGS",offset cbStrings

	// Walk the topics
	mov edi,[pTopics]
	:

	mov esi,[pStrings]
	add esi,[edi+TOPICS.pName]
	// These are ANSI strings so convert them to UNICODE (this is a UNICODE app)
	invoke MultiByteToWideChar,CP_ACP,NULL,esi,-1,offset ObjBuffer,256
	invoke SendMessage,[hListbox],LB_ADDSTRING,0,offset ObjBuffer
	// Save the offset into the UrlTbl that applies to this item
	// This information is used by URLFromIDXTopic to get the path
	// to the HTML document related to this entry
	invoke SendMessage,[hListbox],LB_SETITEMDATA,eax,[edi+TOPICS.pURLTBL]

	// Check for the end of data and loop
	add edi,SIZEOF TOPICS
	cmp edi,[eoTopics]
	jl <<

	// Done with the buffers so free them
	invoke GlobalFree,[pTopics]
	invoke GlobalFree,[pStrings]
	ret
endf

SetUpTabs FRAME hTabControl
	LOCAL ts:TCITEM

	mov D[ts.mask],TCIF_TEXT
	mov D[ts.lpReserved1],0
	mov D[ts.lpReserved2],0
	mov D[ts.cchTextMax],0
	mov D[ts.iImage],-1
	mov D[ts.lParam],0
	push "File tree"
	pop [ts.pszText]
	invoke SendMessage,[hTabControl],TCM_INSERTITEM,0,OFFSET ts
	push "Keywords"
	pop [ts.pszText]
	invoke SendMessage,[hTabControl],TCM_INSERTITEM,1,OFFSET ts

	ret
endf

ReadStream FRAME pStorage, pMemory, pwszStreamName, pcbCopied
	uses ebx
	LOCAL pStream:%PTR
	LOCAL statstg:STATSTG

	// Reads a stream into the memory buffer supplied
	// the size of the buffer must be in the location pointed
	// to by pcbCopied. Returns the number of bytes read in the
	// location pointed to by pcbCopied

	xor ebx,ebx

	// Check the IStorage pointer for NULL
	cmp D[pStorage],0
	je >>.NOINTERFACE

	// Get a pointer to the IStream interface for the file
	CoInvoke(pStorage,IStorage.OpenStream,[pwszStreamName],0,STGM_SHARE_EXCLUSIVE,0,offset pStream)
	test eax,eax
	jnz >>.NOINTERFACE

	// Get the STATSTG information for the stream (to find the size)
	CoInvoke(pStream,IStream.Stat,offset statstg,STATFLAG_NONAME)
	// Only the low order DWORD is used for the size
	// this assumes that the CHM is under 4GB.
	mov ebx,[statstg.cbSize]

	// Check for a NULL buffer size if its NULL then return the
	// required size
	mov eax,[pcbCopied]
	mov eax,[eax]
	test eax,eax
	jz >>.BUFFERTOOSMALL

	// Save the buffer size
	push eax

	// If the buffer size is larger than the actual stream size
	// use the stream size instead
	cmp eax,ebx
	jle >
		mov eax,ebx
	:

	// Read the stream into the memory buffer supplied
	CoInvoke(pStream,IStream.Read,[pMemory],eax,[pcbCopied])

	// Restore the buffer size
	pop eax

	// Get the actual number of bytes read
	mov ecx,[pcbCopied]
	mov ecx,[ecx]

	// Check that there is no unread data
	cmp ecx,eax
	jg >.BUFFERTOOSMALL

	// Release the interface
	CoInvoke(pStream,IStream.IUnknown.Release)
	invoke SetLastError,0
	xor eax,eax
	RET

	.BUFFERTOOSMALL
	// This is executed if the buffer is too small or
	// there is unread data. It sets the error code and
	// returns the number of total bytes necessary to
	// read the stream in EAX

	// Release the interface
	CoInvoke(pStream,IStream.IUnknown.Release)
	invoke SetLastError,ERROR_MORE_DATA
	mov eax,ebx
	RET

	.NOINTERFACE
	// For some reason the stream did not return an IStream interface
	// Most likely that it was not found. Return -1
	invoke SetLastError,ERROR_FILE_NOT_FOUND
	mov eax,-1
	RET
ENDF

OpenCHM FRAME pwszChmFile, ppITSStore, ppStorage
	// Opens a CHM file and returns a pointer to an IITStorage and IStorage interface

	// Note that there is a limitation in the CoInvoke macros, registers containing
	// pointers to vtable pointers should not be dereferenced before using them. This
	// makes the code look wrong but it is what it is.

	mov eax,[ppStorage]
	mov edx,[eax]
	test edx,edx
	jz >
		push eax
		CoInvoke(eax,IStorage.IUnknown.Release)
		pop eax
		mov D[eax],0
	:

	mov eax,[ppITSStore]
	mov edx,[eax]
	test edx,edx
	jz >
		push eax
		CoInvoke(eax,IITStorage.IUnknown.Release)
		pop eax
		mov D[eax],0
	:

	invoke CoCreateInstance,offset CLSID_MSITStore, NULL, CLSCTX_ALL,offset IID_IITStorage, [ppITSStore]
	test eax,eax
	jnz >>.NOINTERFACE
	mov eax,[ppITSStore]
	CoInvoke(eax,IITStorage.StgOpenStorage,[pwszChmFile],0,STGM_READ,0,0,[ppStorage])
	test eax,eax
	jnz >>.NOSTGINTERFACE

	RET
	.NOSTGINTERFACE
		mov eax,[ppITSStore]
		CoInvoke(eax,IStorage.IUnknown.Release)
	.NOINTERFACE
		mov eax,-1
	ret
ENDF

URLFromIDXTopic FRAME pStgStream,offsetUrlTbl, ppUrl
	uses ebx,esi,edi
	LOCAL pUrlTbl:%PTR
	LOCAL pUrlStr:%PTR
	LOCAL cbUrlTbl:D
	LOCAL cbUrlStr:D

	// Returns the HTML document in the buffer supplied in ppUrl

	// Calling ReadStream with a bytecount of NULL
	// will return the size of the stream in eax
	mov D[cbUrlTbl],NULL
	invoke ReadStream,[pStgStream],NULL,L"#URLTBL",offset cbUrlTbl
	mov [cbUrlTbl],eax

	mov D[cbUrlStr],NULL
	invoke ReadStream,[pStgStream],NULL,L"#URLSTR",offset cbUrlStr
	mov [cbUrlStr],eax

	invoke GlobalAlloc,GMEM_FIXED,[cbUrlTbl]
	mov [pUrlTbl],eax
	invoke GlobalAlloc,GMEM_FIXED,[cbUrlStr]
	mov [pUrlStr],eax

	// Read #URLTBL
	invoke ReadStream,[pStgStream],[pUrlTbl],L"#URLTBL",offset cbUrlTbl

	// Read #URLSTR
	invoke ReadStream,[pStgStream],[pUrlStr],L"#URLSTR",offset cbUrlStr

	mov esi,[pUrlTbl]
	add esi,[offsetUrlTbl]

	mov ebx,[pUrlStr]
	add ebx,[esi+URLTBL.pUrlString]
	add ebx,URLSTR.szFilename
	invoke MultiByteToWideChar,CP_ACP,NULL,ebx,-1,[ppUrl],256

	invoke GlobalFree,[pUrlTbl]
	invoke GlobalFree,[pUrlStr]
	ret
endf

EnumerateCHMStreams FRAME pStorage, Type, pCallback, lParam
	LOCAL cCount:D
	LOCAL cFetched:D
	LOCAL pIEnum :%PTR
	LOCAL statstg:STATSTG

	// Function : EnumerateCHMStreams
	// Parameters :
	// pStorage = pointer to an IITStorage interface
	// Type = the type of item that should be enumerated
	// pCallback = pointer to an callback function
	// lParam = application defined value passed to the callback

	// Enumerates the streams in the file and passes a pointer to 
	// an STATSTG structure to an application defined callback
	// The enumeration handles freeing the memory allocated by the
	// enumeration object
	// The callback routine should return TRUE to continue the enumeration
	// or FALSE to stop it

	// Reset the counter
	mov D[cCount],1

	// Check for invalid pointers
	cmp D[pStorage],0
	je >>.NOINTERFACE
	cmp D[pCallback],0
	je >>.NOINTERFACE

	// Get an enumeration interface pointer
	CoInvoke(pStorage,IStorage.EnumElements,0,0,0,offset pIEnum)
	cmp D[pIEnum],0
	je >>.NOINTERFACE
	test eax,eax
	jnz >>.NOINTERFACE
	// Walk through the enumeration
	:
		CoInvoke(pIEnum,IEnumSTATSTG.Next,1,offset statstg,offset cFetched)
		cmp D[cFetched],0
		jz >>.ENDENUM
		// Check to see if the type matches
		mov eax,[statstg.type]
		cmp D[Type],0
		je >>.CALLENUM
		and eax,[Type]
		test eax,eax
		jz >>.NOCALLBACK

		.CALLENUM
		// pass the data to the callback
		invoke [pCallback],[pStorage], [cCount],offset statstg, [lParam]
		// push the return result from the callback
		push eax
		// The name is allocated by the enumeration and must be freed
		invoke CoTaskMemFree,[statstg.pwcsName]
		pop eax
		test eax,eax
		jz >>.ENDENUM
		.NOCALLBACK
		inc D[cCount]
		jmp <<

	.ENDENUM

	// Reset and release the enumeration
	CoInvoke(pIEnum,IEnumSTATSTG.Reset)
	CoInvoke(pIEnum,IEnumSTATSTG.IUnknown.Release)
	xor eax,eax
	RET

	.NOINTERFACE
	mov eax,-1
	RET
ENDF

EnumerationCallback FRAME pStorage, count, pSTATSTG, lParam
	uses edi,esi,ebx
	LOCAL pSubStor:%PTR
	LOCAL Storage[1024]:%TCHAR
	LOCAL hParent:%HANDLE

	// Example of using the enumeration
	// This will recursively walk all storage items
	// and display a list of files

	mov ebx,[pSTATSTG]
	mov edi,[ebx+STATSTG.pwcsName]

	mov eax,[ebx+STATSTG.type]
	cmp eax,1
	je >>.ISSTORAGE

	invoke AddTVStream,[hStores],[lParam],edi

	mov eax,TRUE
	RET

	.ISSTORAGE

	invoke AddTVStorage,[hStores],[lParam],edi,[pStorage]
	mov [hParent],eax
	// The item is a storage so open it
	CoInvoke(pStorage, IStorage.OpenStorage,edi,0,STGM_READ | STGM_SHARE_EXCLUSIVE | STGM_DIRECT,0,0,offset pSubStor)

	invoke EnumerateCHMStreams,[pSubStor], ENUM_STGTY_ALL, offset EnumerationCallback, [hParent]

	// Maybe do this afterwards ?
	CoInvoke(pSubStor,IStorage.IUnknown.Release)

	mov eax,TRUE
	ret

ENDF

AddTVStorage FRAME hTreeview, hParent, pszText, pStorage
	LOCAL tvins:TVINSERTSTRUCT

	mov eax, [pszText]
	mov [tvins.itemex.pszText],eax
	mov eax, [hParent]
	mov D[tvins.hParent],eax
	mov eax,[pStorage]
	mov D[tvins.itemex.lParam],eax
	mov D[tvins.hInsertAfter],0
	mov D[tvins.itemex.mask],TVIF_TEXT + TVIF_PARAM + TVIF_IMAGE + TVIF_SELECTEDIMAGE + TVIF_CHILDREN
	mov D[tvins.itemex.cChildren],TRUE
	mov D[tvins.itemex.iImage],1
	mov D[tvins.itemex.iSelectedImage],1
	invoke SendMessage,[hTreeview],TVM_INSERTITEM,0,OFFSET tvins

	ret
endf

AddTVStream FRAME hTreeview, hParent, pszText
	LOCAL tvins:TVINSERTSTRUCT

	mov eax, [pszText]
	mov [tvins.itemex.pszText],eax
	mov eax, [hParent]
	mov D[tvins.hParent],eax
	mov D[tvins.itemex.lParam],eax
	mov D[tvins.hInsertAfter],0
	mov D[tvins.itemex.mask],TVIF_TEXT + TVIF_PARAM + TVIF_IMAGE + TVIF_SELECTEDIMAGE + TVIF_CHILDREN
	mov D[tvins.itemex.cChildren],FALSE
	mov D[tvins.itemex.iImage],0
	mov D[tvins.itemex.iSelectedImage],0
	invoke SendMessage,[hTreeview],TVM_INSERTITEM,0,OFFSET tvins

	ret
endf

GetKeywordBTREE FRAME hListbox, pStorage, pMemory, pcbCopied
	uses ebx
	LOCAL pWWKeywordLinks:%PTR
	LOCAL pStream:%PTR
	LOCAL statstg:STATSTG
	LOCAL cbRead:D
	LOCAL pMap:%PTR
	LOCAL PropertyData[16]:D
	
	LOCAL nBlocks:D
	LOCAL nKeywords:D

	// First get an instance for the $WWKeywordLinks storage item
	CoInvoke(pStorage, IStorage.OpenStorage,L"$WWKeywordLinks",0,STGM_READ | STGM_SHARE_EXCLUSIVE | STGM_DIRECT,0,0,offset pWWKeywordLinks)
	test eax,eax
	jnz >>.NOINTERFACE
	
	CoInvoke(pWWKeywordLinks,IStorage.OpenStream,L"Property",0,STGM_SHARE_EXCLUSIVE,0,offset pStream)
	CoInvoke(pStream,IStream.Read,offset PropertyData,64,offset cbRead)
	CoInvoke(pStream,IStream.IUnknown.Release)
	// Signature is (dwords) 0, 0, 0, 0xC, 1, 1, 0, 0
	// Since all fields are 0 if the section is empty
	// we'll just check for 0xC at byte 12
	cmp D[PropertyData+12],12
	jne >>.NOSTREAM

	CoInvoke(pWWKeywordLinks,IStorage.OpenStream,L"Map",0,STGM_SHARE_EXCLUSIVE,0,offset pStream)
	CoInvoke(pStream,IStream.Stat,offset statstg,STATFLAG_NONAME)
	invoke GlobalAlloc,GMEM_FIXED,[statstg.cbSize]
	mov [pMap],eax
	CoInvoke(pStream,IStream.Read,[pMap],[statstg.cbSize],offset cbRead)
	CoInvoke(pStream,IStream.IUnknown.Release)
	
	mov eax,[pMap]
	mov ecx,[eax] // Number of listing blocks in BTree
	mov [nBlocks],ecx

	// Get the total number of keywords
	mov ebx,eax
	dec ecx // Subtract 1 to convert to 0 based index
	shl ecx,3 // 2 DWORDs per entry so multiply by 8
	add ebx,2 // Skip the first WORD
	add ebx,ecx // move pointer to the last record
	mov eax,[ebx] // Get the number of keywords
	mov [nKeywords],eax
	invoke GlobalFree,[pMap]

	// Get an instance for the BTree
	CoInvoke(pWWKeywordLinks,IStorage.OpenStream,L"BTree",0,STGM_SHARE_EXCLUSIVE,0,offset pStream)
	test eax,eax
	jnz >>.NOSTREAM

	// Get the size of the BTree entry
	CoInvoke(pStream,IStream.Stat,offset statstg,STATFLAG_NONAME)
	mov ebx,[statstg.cbSize]
	mov eax,[pcbCopied]
	mov eax,[eax]
	test eax,eax
	jz >>.BUFFERTOOSMALL
	cmp ebx,eax
	jg >>.BUFFERTOOSMALL

	// Read the BTree
	CoInvoke(pStream,IStream.Read,[pMemory],eax,[pcbCopied])

	CoInvoke(pStream,IStream.IUnknown.Release)
	CoInvoke(pWWKeywordLinks,IStorage.IUnknown.Release)

	// Parse the tree
	invoke WalkKeywords,[hListbox],NULL,[pMemory]

	xor eax,eax
	ret

	.NOSTREAM
	invoke SetLastError,ERROR_FILE_NOT_FOUND
	CoInvoke(pWWKeywordLinks,IStorage.IUnknown.Release)
	xor eax,eax
	dec eax
	ret

	.NOINTERFACE
	invoke SetLastError,ERROR_PATH_NOT_FOUND
	xor eax,eax
	dec eax
	ret

	.BUFFERTOOSMALL
	// Release the interface
	CoInvoke(pStream,IStream.IUnknown.Release)
	CoInvoke(pWWKeywordLinks,IStorage.IUnknown.Release)
	invoke SetLastError,ERROR_MORE_DATA
	mov eax,ebx
	RET

endf

WalkKeywords FRAME hLb, ppKeywords, pBTree
	uses ebx,edi,esi
	LOCAL pKeywords:%PTR
	LOCAL nKeywords:D
	LOCAL nBlocks:D
	LOCAL NextBlock:D
	LOCAL padding:D
	LOCAL szKeyWord[256]:B
	LOCAL szwKeyWord[512]:B
	LOCAL count:D

	mov D[count],0

	// Walks the keyword BTree
	// This function allocates memory and returns a pointer to that
	// memory in ppKeywords. The memory must be released using CoTaskMemFree
	// when it is no longer needed

	// Read the BTree header
	// Because there is only one format that I could
	// find any documentation for several checks are
	// made to ensure that the file is in that format

	mov ebx,[pBTree]
	mov eax,[ebx]
	// Check the signature must be ";)" seriously, someone with a sense of humour at Microsoft ?
	cmp ax,0x293B
	jne >>.BADFORMAT
	;;karen bean 403 520 2102 Day hospital program
	mov ecx,ebx
	add ecx,BTREEHEADER.sFormat
	// The only format we recognize is X44
	invoke lstrcmpiA,ecx,A"X44"
	test eax,eax
	jnz >>.BADFORMAT
	// OK its pretty sure that this file can be read so begin parsing it

	// Allocate enough memory to hold the keyword data we're interested in
	mov eax,[ebx+BTREEHEADER.nKeywords]
	mov [nKeywords],eax
	mov ecx,SIZEOF KEYWORDENTRY
	mul ecx
	invoke CoTaskMemAlloc,eax
	mov esi,eax

	mov eax,[ebx+BTREEHEADER.nBlocks]
	mov [nBlocks],eax

	mov edi,ebx
	add edi,SIZEOF BTREEHEADER
	// Walk the listing blocks
	.NEXTBLOCK
		// Need some info about this block
		mov eax,[edi+BTREELBHEADER.iNext]
		mov [NextBlock],eax
		mov eax,[edi+BTREELBHEADER.lPadding]
		and eax,0xffff
		mov [padding],eax
		mov edx,[edi+BTREELBHEADER.nEntries]
		and edx,0xFFFF

		add edi, SIZEOF BTREELBHEADER
		.NEXTKEYWORD
		// Parse the listings
		// Copy the keyword string to the buffer
		push edx
		invoke lstrcpy,esi,edi
		invoke lstrlen,esi
		pop edx
		// Skip past the keyword string
		// The string is variable length so we have to
		// use offsets for the rest
		shl eax,1 // Multiply WCHAR by 2
		add edi,eax
		add edi,2 // Skip past NULL terminator
		mov eax,esi
		add eax,KEYWORDENTRY.KeywordFlag
		xor ecx,ecx
		mov cx,[edi]
		mov [eax],ecx
		add edi,0x10 // Index into #TOPICS file or See Also string
		// Make sure its not a SEE ALSO
		cmp D[esi+KEYWORDENTRY.KeywordFlag],0
		jne >>.SEEALSO
		mov eax,esi
		add eax,KEYWORDENTRY.TopicIndex
		mov ecx,[edi]
		mov [eax],ecx

		push edx
		invoke SendMessage,[hLb],LB_ADDSTRING,0,esi
		mov ecx,[esi+KEYWORDENTRY.TopicIndex]
		invoke SendMessage,[hLb],LB_SETITEMDATA,eax,ecx
		pop edx

		jmp >>.GOTONEXT

		.SEEALSO
		// I have no examples of this to test against so just ignore it
		// For whatever reason the entry is truncated so adjust our pointer
		// to reflect the missing data
		sub edi,12
		sub edi,SIZEOF BTREELBHEADER

		.GOTONEXT

		add esi,SIZEOF KEYWORDENTRY
		add edi,12 // Skip over the last 12 bytes of useless information
		dec edx
		jnz <<.NEXTKEYWORD
		// Get the amount of padding
		add edi,[padding]
		cmp D[NextBlock],-1
		jne <<.NEXTBLOCK

	ret
	
	.BADFORMAT
	xor eax,eax
	dec eax
	ret
endf
